unit Main;

{
  : ZuBy ( )
  rzaripov1990@gmail.com
  http://zuby.ucoz.kz
  2014
}

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.ListBox,
  FMX.StdCtrls, FMX.Effects, FMX.Gestures, FMX.Ani, FMX.Layouts,
  FMX.Filter.Effects;

type
  TForm1 = class(TForm)
    lbCaption: TLabel;
    lbMain: TListBox;
    btnHide: TButton;
    GestureManager1: TGestureManager;
    FloatPanel: TPanel;
    FloatMenu: TListBox;
    FloatAnimation1: TFloatAnimation;
    BlurEffect1: TBlurEffect;
    ToolBar1: TToolBar;
    ListBoxItem1: TListBoxItem;
    ListBoxItem2: TListBoxItem;
    ListBoxGroupFooter1: TListBoxGroupFooter;
    ListBoxItem3: TListBoxItem;
    GlowEffect1: TGlowEffect;
    procedure lbMainGesture(Sender: TObject; const EventInfo: TGestureEventInfo; var Handled: Boolean);
    procedure FloatMenuItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
    procedure FormResize(Sender: TObject);
    procedure btnHideClick(Sender: TObject);
  private
    procedure HideFloatMenu;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FloatMenuWidth: integer;
  UseEffect: Boolean = false;

implementation

{$R *.fmx}

procedure TForm1.btnHideClick(Sender: TObject);
begin
  HideFloatMenu; //  
end;

procedure TForm1.FloatMenuItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
var
  aItem: TListBoxItem;
begin
  case Item.Index of
    0:
      begin
        aItem := TListBoxItem.Create(nil);
        aItem.Parent := lbMain;
        aItem.StyleLookup := 'listboxitemnodetail';
        aItem.Text := ' ' + IntToStr(Random(1000));
      end;
    1:
      begin
        if lbMain.Items.Count > 0 then
          lbMain.Items.Delete(lbMain.Items.Count - 1);
      end;
    3:
      begin
        UseEffect := not UseEffect; // / 
        if FloatPanel.Width = FloatMenuWidth then //    ,  /
          BlurEffect1.Enabled := UseEffect;
      end;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  FloatMenuWidth := ClientWidth - 120; //   
  FloatPanel.Position.X := 0; //    
  FloatPanel.Position.Y := ToolBar1.Height; //   
end;

procedure TForm1.HideFloatMenu;
begin
  if FloatPanel.Width = 0 then //   ,  
    Exit;
  BlurEffect1.Enabled := false; //   
  btnHide.Visible := false; //   
  with FloatAnimation1 do
  begin
    StartValue := FloatMenuWidth;
    StopValue := 0;
    Start; //  
  end;
end;

procedure TForm1.lbMainGesture(Sender: TObject; const EventInfo: TGestureEventInfo; var Handled: Boolean);
begin
  case EventInfo.GestureID of
    sgiRight: //  
      begin
        if FloatPanel.Width = FloatMenuWidth then //   ,  
          Exit;
        btnHide.Visible := true; //   
        BlurEffect1.Enabled := UseEffect; //   
        with FloatAnimation1 do
        begin
          StartValue := 0;
          StopValue := FloatMenuWidth;
          Start; //  
        end;
      end;
    sgiLeft:
      HideFloatMenu; //  
  end;
end;

end.
